// material-ui
import {
    Box,
    Grid, Typography
} from '@mui/material';
import MainCard from "../../components/MainCard";
import ClientDepartmentSearchForm from "./ClientDepartmentSearchForm";
import ClientDepartmentTable from "./ClientDepartmentTable";
import {useEffect, useState} from "react";
import axios from "axios";
import {apiPath} from "../../auth/utils";
import {GET_CLIENT_DEPARTMENT_LIST} from "../../utils/ApiPathConst";
import LoadingComponent from "../extra-pages/LoadingComponent";
import * as React from "react";

import {LIONER_FORM_THEME, CARD_MAX_WIDTH} from "../../themes/themeConst";
import {ThemeProvider} from "@emotion/react";

// ==============================|| DASHBOARD - DEFAULT ||============================== //

const ChannelSearchPanel = () => {

    const [record, setRecord] = useState([]);
    const [searchCriteria, setSearchCriteria] = useState({});
    const [onReady, setOnReady] = useState(false);

    useEffect(() => {
        getGroupList();
    }, []);

    useEffect(() => {
        setOnReady(true);
    }, [record]);

    useEffect(() => {
        getGroupList();
    }, [searchCriteria]);

    function getGroupList() {
        axios.get(`${apiPath}${GET_CLIENT_DEPARTMENT_LIST}`,
            {params: searchCriteria}
        )
            .then((response) => {
                if (response.status === 200) {
                    setRecord(response.data.records);
                }
            })
            .catch(error => {
                console.log(error);
                return false;
            });
    }

    function applySearch(input) {
        setSearchCriteria(input);
    }

    return (
        !onReady ?
            <LoadingComponent/>
            :
            <Grid container rowSpacing={3} columnSpacing={2.75}>
                <ThemeProvider theme={LIONER_FORM_THEME}>
                <Grid item xs={12} md={12} lg={12} sx={{mt:-1}}>
                    <Grid container justifyContent="flex-start" alignItems="center">
                        <Grid item xs={3} sx={{mb: -2.25}} >
                            <Box sx={{ display: 'flex', alignItems: 'center'}}>
                                <Typography align="center" variant="h5" >View Client Department</Typography>
                            </Box>
                        </Grid>
                    </Grid>
                </Grid>

                {/*row 1*/}
                <Grid item xs={12} md={12} lg={12}>
                    <ClientDepartmentSearchForm applySearch={applySearch}/>
                </Grid>
                {/*row 2*/}
                <Grid item xs={12} md={12} lg={12} sx={{mt:{lg:-1.5}}}>
                    <MainCard elevation={0}
                              content={false}
                              sx={{width:CARD_MAX_WIDTH}}
                    >
                        <ClientDepartmentTable
                            recordList={record}
                        />
                    </MainCard>
                </Grid>
                </ThemeProvider>
            </Grid>

    );
};

export default ChannelSearchPanel;
